#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Oct 30 10:21:27 2020

@author: lucia
"""

import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
import pandas as pd
from scipy.ndimage.filters import maximum_filter
from scipy.ndimage.morphology import generate_binary_structure

def espectrograma(corr):
    #Espectrograma
    plt.figure(figsize=(8,4))
    sns.heatmap(corr, cmap="YlGnBu")
    plt.ylabel('Número de plantilla')
    plt.xlabel('Muestras')

# Plot 3D
def plot_3D(corr):
    
    corr = np.array(corr)
    corr = pd.DataFrame(corr)

    df = corr.unstack().reset_index()
    df.columns = ["X","Y","Z"]
    
    # Make the plot
    fig = plt.figure()
    ax = fig.gca(projection='3d')
    #ax.plot_trisurf(df['Y'], df['X'], df['Z'], cmap=plt.cm.viridis, linewidth=0.2)
    ax.plot_trisurf(df['Y'], df['X'], df['Z'], cmap=plt.cm.jet, linewidth=0.2)
    plt.show()


# Detect peaks in matrix
def findpeaks(image, thresh):
    """
    Return positions of all peaks in image above threshold thresh
    Based on `"detect_peaks" Stack Overflow discussion <https://stackoverflow.com/questions/3684484/peak-detection-in-a-2d-array/3689710#3689710>`_
    
    :param image: array of values to search
    :param thresh: threshold for peaks
    :type image: numpy.ndarray
    :type thresh: float
    :returns: index array (equivalent of where output)
    """
    # define an 8-connected neighborhood
    neighborhood = generate_binary_structure(2,2)
    # find local maximum for each pixel
    amax = maximum_filter(image, footprint=neighborhood)
    w = np.where((image == amax) & (image >= thresh))
    return w 



###############################################################################
#         Comienzo del Main
###############################################################################
